/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Wed Jun 5 2002
    copyright            : (C) 2002 by root
    email                : root@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include <stdio.h>
#include <curses.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include "head.h"
#include "structs.h"



void clearLine(int line,int startPos)
{
	
	for(;startPos<COLS-1;startPos++) {
		move(line,startPos);
		printw(" ");
	}
}
void getUserName(void)
{
	void addMsg(char *msg);
	void printMsg(u8);
	char *prompt(char *text,int len),*input;
	int writeUserName(char *nameTry);
	for(;;) {
		input=prompt("Enter user name: ",15);
		if(writeUserName(input)==1) {
			strcpy(name,input);
			free(input);
			break;
		}
		free(input);
		clearLine(LINES-2,1);
	}
	clearLine(LINES-2,1);
}
void startTest(void)
{
	char *input,buffer[32];
	void addMsg(char *msg,u8);
	void printMsg(u8);
	char *prompt(char *text,int len);
	int writeNewMsg(char *msg);
	
	sprintf(buffer,"system: uid=%d",uid);
	addMsg(buffer,1);
	printMsg(upoffset);
	for(;!exitConfirmed;) {
		move(LINES-2,1);
		echo();
		sprintf(buffer,"%s: ",name);
		input=prompt(buffer,255);
		noecho();
		clearLine(LINES-2,1);
		addMsg(input,0);
		printMsg(upoffset);
		if(writeNewMsg(input)!=1) {
			addMsg("system: ERROR",1);
			printMsg(upoffset);
		}
		if(strcmp("/exit",input)==0) {
			free(input);
			break;
		}
		
		free(input);
	}
}
int getPort(char *server)
{
	u8 i;
	for(i=0;i<strlen(server);i++)
		if(server[i]==':')
			break;
	return atoi(&server[i+1]);
}
void connectServer()
{
	void addMsg(char *msg,u8);
	void clearSpace(void);
	void printMsg(u8);
	char *buffer;
	int checkConnect(char *server,int port);
	addMsg("system: type ip or DNS address",1);
	printMsg(upoffset);
	for(;!exitConfirmed;) {
		buffer=prompt("-> ",255);
		clearLine(LINES-2,1);
		refresh();
		if(checkConnect(buffer,getPort(buffer))) {
			addMsg("system: Connected",1);
			clearSpace();
			printMsg(upoffset);
			serverName=buffer;
			serverPort=getPort(buffer);
			break;
		} else {
			addMsg("system: Cant connect to that server",1);
		}
		clearSpace();
		printMsg(upoffset);
		
		if(strcmp(buffer,"exit")==0) {
			free(buffer);
			break;
		}
		free(buffer);
	}
}
int main(void)
{
	int getUpdate(void);
	void printBox(void);
	void addMsg(char *msg);
	void printMsg(void);
	
	initscr();
	if(has_colors())
		start_color();
	scrollok(stdscr,FALSE);
	keypad(stdscr,TRUE);
	curs_set(0);
	noecho();
	
	antMsg=0;
	upoffset=0;
	currentPos.x=0;
	currentPos.y=0;
	exitConfirmed=0;
	
	init_pair(NAME,COLOR_BLUE,COLOR_BLACK);
	init_pair(SYSTEM,COLOR_CYAN,COLOR_BLACK);
	init_pair(USERS,COLOR_MAGENTA,COLOR_BLACK);
	init_pair(TEXT,COLOR_WHITE,COLOR_BLACK);
	
	//init_pair(NAME,COLOR_WHITE,COLOR_BLACK);
	//init_pair(SYSTEM,COLOR_WHITE,COLOR_BLACK);
	//init_pair(USERS,COLOR_WHITE,COLOR_BLACK);
	//init_pair(TEXT,COLOR_WHITE,COLOR_BLACK);
	
	CU.antUpdates=0;
	
	printBox();
	
	
	
	connectServer();
	
	//----------------------------------------
	
	
	
	CU.antUpdates=1;
	CU.func=(void**)malloc(1*sizeof(void*));
	CU.func[0]=getUpdate;
	
	getUserName();
	
	startTest();
	//----------------------------------------
	free(CU.func);
	
	clear();
	
	curs_set(1);
	scrollok(stdscr,FALSE);
	keypad(stdscr,FALSE);
	echo();
	endwin();
	return 0;
}
void clearSpace(void)
{
	u8 i;
	for(i=1;i<LINES-3;i++)
		clearLine(i,1);
}
void makeLine(u8 pos)
{
	u8 i;
	move(pos,0);
	echochar(ACS_LTEE);
	move(pos,COLS-1);
	echochar(ACS_RTEE);
	for(i=1;i<COLS-1;i++) {
		move(pos,i);
		echochar(ACS_HLINE);
	}
}
void deleteLine(u8 pos)
{
	move(pos,0);
	echochar(ACS_VLINE);
	move(pos,COLS-1);
	echochar(ACS_VLINE);
	clearLine(pos,1);
}



