/***************************************************************************
                          network.c  -  description
                             -------------------
    begin                : Thu Jun 6 2002
    copyright            : (C) 2002 by root
    email                : root@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <sys/socket.h>
#include "head.h"
#include "structs.h"


int writeNewMsg(char *msg)
{
	int socket_fd=-1;
  struct sockaddr_in name;
  struct hostent* hostinfo;
	char buffer[255];
	if(serverPort==0) {
  	return 0;
  }
	socket_fd = socket (PF_INET, SOCK_STREAM, 0);
	if(socket_fd==-1) {
		return 0;
	}
	fcntl(socket_fd,O_NONBLOCK);
  name.sin_family = AF_INET;
  hostinfo = gethostbyname (serverName);
  if (hostinfo == NULL) {
  	close(socket_fd);
    return 0;
  } else
	  name.sin_addr = *((struct in_addr *) hostinfo->h_addr);
  name.sin_port = htons (serverPort);
  if(connect (socket_fd, &name, sizeof (struct sockaddr_in)) == -1) {
  	close(socket_fd);
  	return 0;
  }
	sprintf(buffer,"NEW%d %s",uid,msg);
	if(write(socket_fd,buffer,strlen(buffer)+1)!=strlen(buffer)+1) {
 		close(socket_fd);
 		return 0;
 	}
	close(socket_fd);
	return 1;
}
int writeUserName(char *nameTry)
{
	int socket_fd=-1;
  struct sockaddr_in name;
  struct hostent* hostinfo;
	char buffer[255];
	void addMsg(char *msg,u8);
	void printMsg(u8);
	if(serverPort==0) {
		addMsg("system: Port error",1);
		printMsg(upoffset);
  	return 0;
  }
	socket_fd = socket (PF_INET, SOCK_STREAM, 0);
	if(socket_fd==-1) {
		addMsg("system: Socket error",1);
		printMsg(upoffset);
		return 0;
	}
	fcntl(socket_fd,O_NONBLOCK);
  name.sin_family = AF_INET;
  hostinfo = gethostbyname (serverName);
  if (hostinfo == NULL) {
  	close(socket_fd);
  	addMsg("system: Info error",1);
		printMsg(upoffset);
    return 0;
  } else
	  name.sin_addr = *((struct in_addr *) hostinfo->h_addr);
  name.sin_port = htons (serverPort);
  if(connect (socket_fd, &name, sizeof (struct sockaddr_in)) == -1) {
  	close(socket_fd);
  	addMsg("system: Connection error",1);
		printMsg(upoffset);
  	return 0;
  }
	sprintf(buffer,"NAME%d %s",uid,nameTry);
	if(write(socket_fd,buffer,strlen(buffer)+1)!=strlen(buffer)+1) {
 		close(socket_fd);
 		addMsg("system: Writing error",1);
		printMsg(upoffset);
 		return 0;
 	}
 	read(socket_fd,buffer,255);
	close(socket_fd);
	if(strncmp(buffer,"OK",2)==0) {
		addMsg("system: Your nick is ok",1);
		printMsg(upoffset);
		return 1;
	} else if(strncmp(buffer,"INUSE",5)==0) {
		addMsg("system: Your nick is in use",1);
		printMsg(upoffset);
		return 0;
	} else if(strncmp(buffer,"TOLONG",6)==0) {
		addMsg("system: Your nick is to long",1);
		printMsg(upoffset);
		return 0;
	}
	return 0;
}
int getUpdate(void)
{
	int socket_fd=-1;
	void addMsg(char *,u8);
	void clearSpace(void);
	void printMsg(u8);
  struct sockaddr_in name;
  struct hostent* hostinfo;
	char buffer[255];
	
	if(serverPort==0) {
  	return 0;
  }
	socket_fd = socket (PF_INET, SOCK_STREAM, 0);
	if(socket_fd==-1) {
		return 0;
	}
	name.sin_family = AF_INET;
  hostinfo = gethostbyname (serverName);
  if (hostinfo == NULL) {
  	close(socket_fd);
    return 0;
  } else
	  name.sin_addr = *((struct in_addr *) hostinfo->h_addr);
  name.sin_port = htons (serverPort);
  if(connect (socket_fd, &name, sizeof (struct sockaddr_in)) == -1) {
  	close(socket_fd);
  	return 0;
  }
	sprintf(buffer,"UPDATE%d",uid);
	if(write(socket_fd,buffer,strlen(buffer)+1)!=strlen(buffer)+1) {
 		close(socket_fd);
 		return 0;
 	}
 	buffer[0]='\0';
	read(socket_fd,buffer,255);
	close(socket_fd);
	
	if(strncmp(buffer,"KICKED",6)==0) {
		addMsg("system: You have been kicked",1);
		printMsg(upoffset);
		exitConfirmed=1;
		return -1;
	} else if(strncmp(buffer,"NONE",4)!=0) {
		addMsg(buffer,1);
		printMsg(upoffset);
	}
	return 1;
}

int checkConnect(char *server,int port)
{
	int socket_fd=-1,i;
	void addMsg(char *);
	void clearSpace(void);
	void printMsg(u8);
  struct sockaddr_in name;
  struct hostent* hostinfo;
	char buffer[10];
	for(i=0;i<strlen(server);i++)
		if(server[i]==':')
			break;
	server[i]='\0';
	if(port==0) {
  	return 0;
  }
	socket_fd = socket (PF_INET, SOCK_STREAM, 0);
	if(socket_fd==-1) {
		return 0;
	}
	fcntl(socket_fd,O_NONBLOCK);
  name.sin_family = AF_INET;
  hostinfo = gethostbyname (server);
  if (hostinfo == NULL) {
  	close(socket_fd);
    return 0;
  } else
	  name.sin_addr = *((struct in_addr *) hostinfo->h_addr);
  name.sin_port = htons (port);
  if(connect (socket_fd, &name, sizeof (struct sockaddr_in)) == -1) {
  	close(socket_fd);
  	return 0;
  }

	if(write(socket_fd,"CONNECTED",10)!=10) {
 		close(socket_fd);
 		return 0;
 	}
	read(socket_fd,buffer,6);
	if(strncmp(buffer,"YES",3)==0) {
		uid=atoi(&buffer[3]);
		close(socket_fd);
		return 1;
	}
	close(socket_fd);
	return 0;
}

