/***************************************************************************
                          uti.c  -  description
                             -------------------
    begin                : Thu Jun 6 2002
    copyright            : (C) 2002 by root
    email                : root@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <stdio.h>
#include <curses.h>
#include <malloc.h>
#include <string.h>
#include <unistd.h>
#include "head.h"
#include "structs.h"
char history[16][255] = {
	"","","","","","","","",
	"","","","","","","",""
};
void printBox(void)
{
  int  i;
	for(i=0;i<LINES;i++) {
		if(i==0) {
			move(i,0);
			echochar(ACS_ULCORNER);
			move(i,COLS-1);
			echochar(ACS_URCORNER);
		} else if(i==LINES-1) {
			move(i,0);
			echochar(ACS_LLCORNER);
			move(i,COLS-1);
			echochar(ACS_LRCORNER);
		} else if(i==LINES-3){
			move(i,0);
			echochar(ACS_LTEE);
			move(i,COLS-1);
			echochar(ACS_RTEE);
		} else if(i!=LINES-1) {
			move(i,0);
			echochar(ACS_VLINE);
			move(i,COLS-1);
			echochar(ACS_VLINE);
		}
	}
	for(i=1;i<COLS-1;i++) {
		move(0,i);
		echochar(ACS_HLINE);
	}
	for(i=1;i<COLS-1;i++) {
		move(LINES-1,i);
		echochar(ACS_HLINE);
	}
	for(i=1;i<COLS-1;i++) {
		move(LINES-3,i);
		echochar(ACS_HLINE);
	}
}
int getInput(void)
{
	int choise=ERR,i;
	void printMsg(u8);
	nodelay(stdscr,TRUE);
	noecho();
	curs_set(1);
	while(choise==ERR)
	{
		for(i=0;i<CU.antUpdates;i++)
			(*CU.func[i])();
				
		choise=getch();
		usleep(5);
		switch(choise)
		{
			case 1:
				clearSpace();
				choise=ERR;
				break;
			case KEY_RESIZE:
				clear();
				printBox();
				printMsg(upoffset);
				choise=ERR;
				break;
		}
	}
	curs_set(0);
	echo();
	nodelay(stdscr,FALSE);
	return choise;
}
void makeSpace(char **txt,int pos)
{
	u8 i;
	for(i=strlen(txt[0])+1;i>pos;i--)
		txt[0][i]=txt[0][i-1];
}
void addChar(char **txt,int pos,char inset)
{
	makeSpace(txt,pos);
	txt[0][pos]=inset;
}
void deleteChar(char **txt,int pos)
{
	u8 i;
	for(i=pos;i<strlen(txt[0]);i++)
		txt[0][i]=txt[0][i+1];
}
void addHistory(char *buffer)
{
	u8 i;
	for(i=16;i>1;i--)
		strcpy(history[i],history[i-1]);
	strcpy(history[1],buffer);
}
void setHistory(char *buffer)
{
	strcpy(history[0],buffer);
}
void printRestText(char *msg,u8 size)
{
	u8 i,y,x;
	for(i=0,y=(LINES-2)-upoffset,x=size+1;i<strlen(msg);i++,x++) {
		if(x==COLS-1) {
			x=size+1;
			y++;
		}
		mvprintw(y,x,"%c",msg[i]);
	}
}
void showText(char *msg,u8 size,char *start)
{
	u8 newoffset;
	int i,e;
	void clearSpace(void);
	
	/*if((int)(strlen(msg)+size)<=(COLS-1)) {
		newoffset=0;
	} else {
		newoffset=(int)((int)((int)(strlen(msg)))/(COLS-1-strlen(start)));
	}
	mvprintw(0,0,"%d %d %d %d        ",newoffset,(u8)((int)((int)(strlen(msg))-1)/(COLS-1-strlen(start))),((int)strlen(msg)-1)/(newoffset+1),COLS-1);
	*/
	for(i=0,newoffset=0,e=0;e<strlen(msg);e++,i++) {
		if(i==COLS-2-(strlen(start)+1)+newoffset) {
			i=0;
			newoffset++;
		}
	}
	if(newoffset>upoffset)
		currentPos.y--;
	if(newoffset<upoffset)
		currentPos.y++;
	if(newoffset==upoffset) {
		for(newoffset=0;newoffset<=upoffset;newoffset++)
			clearLine((LINES-2)-newoffset,1);
		attrset(COLOR_PAIR(NAME));
		mvprintw((LINES-2)-upoffset,1,"%s",start);
		attrset(A_NORMAL);
	} else {
		deleteLine((LINES-3)-upoffset);
		upoffset=newoffset;
		clearSpace();
		printMsg(upoffset);
		makeLine((LINES-3)-upoffset);
		for(newoffset=0;newoffset<=upoffset;newoffset++)
			clearLine((LINES-2)-newoffset,1);
		attrset(COLOR_PAIR(NAME));
		mvprintw((LINES-2)-upoffset,1,"%s",start);
		attrset(A_NORMAL);
	}
	printRestText(msg,strlen(start));
}
char *prompt(char *text,int len)
{
	char *buffer;
	int i,e,f;
	void printMsg(u8);
	u8 hpos=0,pos=0;
	int getInput(void);
	buffer=(char*)malloc(len+1);
	buffer[0]='\0';
	currentPos.x=strlen(text)+1;
	currentPos.y=LINES-2-upoffset;
	for(i=0,f=0,pos=0;;) {
		if(hpos==0)
			setHistory(buffer);
		showText(buffer,strlen(text)+1,text);
		move(currentPos.y,currentPos.x);
		
		e=getInput();
		if(e==KEY_LEFT) {
			if(pos>0) {
				if(currentPos.x==(strlen(text)+1)) {
					currentPos.x=COLS-2;
					currentPos.y--;
				} else {
					currentPos.x--;
				}
				pos--;
			}
		} else if(e==KEY_RIGHT) {
			if(pos<strlen(buffer)) {
				if(currentPos.x==COLS-2) {
					currentPos.x=strlen(text)+1;
					currentPos.y++;
				} else {
					currentPos.x++;
				}
				pos++;
			}
		} else if(e==KEY_NPAGE) { // page down
		} else if(e==KEY_PPAGE) { // page up
		} else if(e==KEY_UP) {
			if(hpos<16) {
				if(strlen(history[hpos+1])>0) {
					clearLine(LINES-2,1+strlen(text));
					hpos++;
					strcpy(buffer,history[hpos]);
					pos=i=strlen(buffer);
					currentPos.x=strlen(text)+1+pos;
				}
			}
		} else if(e==KEY_DOWN) {
			if(hpos>0) {
				clearLine(LINES-2,1+strlen(text));
				hpos--;
				strcpy(buffer,history[hpos]);
				pos=i=strlen(buffer);
				currentPos.x=strlen(text)+1+pos;
			} else if(history[0]!='\0') {
				addHistory(buffer);
				strcpy(buffer,"");
				currentPos.x=strlen(text)+1;
				currentPos.y=LINES-2;
				upoffset=0;
				pos=0;
				i=0;
			}
		} else if(e==KEY_HOME) {
			currentPos.x=(strlen(text)+1);
			currentPos.y=LINES-2-upoffset;
			pos=0;
		} else if(e==KEY_END) {
			currentPos.x=(i%(((COLS-1)-strlen(text))-1))+(strlen(text)+1);
			currentPos.y=LINES-2+upoffset;
			pos=i;
		} else if(e=='\n') {
			break;
		}	else if(e==KEY_DC) {
			if(i>pos) {
				deleteChar(&buffer,pos);
				i--;
			}
		} else if(e==KEY_BACKSPACE) { // backspace
			if(pos>0) {
				if(currentPos.x==strlen(text)+1) {
					currentPos.x=COLS-2;
					currentPos.y--;
				} else {
					currentPos.x--;
				}
				pos--;
				deleteChar(&buffer,pos);
				i--;
			}
		} else if(i==len-4) {
			// do nothing
		} else {
			addChar(&buffer,pos,e);
			if(currentPos.x==COLS-2) {
				currentPos.x=strlen(text)+1;
				currentPos.y++;
			} else {
				currentPos.x++;
			}
			pos++;
			i++;
		}
		refresh();
	}
	//upoffset=0;
	if(i>0)
		addHistory(buffer);
	return buffer;
}
